<?php

/**
* GK Headlines - database helper class
* @package Joomla!
* @Copyright (C) 2009 Gavick.com
* @ All rights reserved
* @ Joomla! is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @version $Revision: 1.0.0 $
**/

// no direct access
defined('_JEXEC') or die('Restricted access');
// Main class
class GKHeadlines_DBHelper
{
	var $_db;
	var $_config;
	
	function GKHeadlines_DBHelper()
	{
		$this->_db =& JFactory::getDBO();
	} 
	
	function getHeadlinesArray($config)
	{
		// getting information about user
		$user =& JFactory::getUser();
		$userId = (int) $user->get('id');
		$aid = $user->get('aid', 0);
		// getting access config
		$contentConfig = &JComponentHelper::getParams( 'com_content' );
		$access	= !$contentConfig->get('show_noauth');
		// getting date variables
		$nullDate	= $this->_db->getNullDate();
		$date =& JFactory::getDate();
		$now = $date->toMySQL();
		// initializing result array
		$result_array = array();				
		// generating category clause
		for($i = 0; $i < count($config['categories']); $i++)
		{
			$catid_clause .= ($i == count($config['categories']) - 1) ? ' a.catid = '.$config['categories'][$i].' ' : ' a.catid = '.$config['categories'][$i].' OR ';
		}	
		// preparing query
		$query =   'SELECT 
						a.id AS art_id,
						a.title AS art_title, 
						'.(($config['date_type'] == 'created') ? 'a.created' : 'a.modified').' AS art_date,
						a.hits AS art_hits,
						
						u.'.($config["author_name"]).' AS art_author, 
						a.sectionid AS art_sectionid,
						c.title AS art_catname,
						CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) 
						ELSE a.id END AS art_slug, 
						CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(":", c.id, c.alias) 
						ELSE c.id END AS cat_slug
					FROM 
						#__content AS a 
					INNER JOIN 
						#__categories AS c ON c.id = a.catid 
					INNER JOIN
						#__users AS u ON u.id = a.created_by	
					WHERE 
						a.state = 1 AND 
						( a.publish_up = '.$this->_db->Quote($nullDate).' OR a.publish_up <= '.$this->_db->Quote($now).' ) AND 
						( a.publish_down = '.$this->_db->Quote($nullDate).' OR a.publish_down >= '.$this->_db->Quote($now).' ) AND 
						'.($access ? ' a.access <= ' .(int) $aid. ' AND c.access <= ' .(int) $aid . ' AND ' : '').' 
						c.published = 1 AND 
						( ' . $catid_clause . ' )
					ORDER BY 
						'.(($date_type == 'created') ? 'a.created' : 'a.modified').' DESC';
		// run query
		$this->_db->setQuery($query,0,$config['item_amount']);
		// getting query result
		$rows = $this->_db->loadObjectList();
		// parsing rows
		if(count($rows) > 0)
		{
			// rows iteration
			foreach($rows as $row)
			{
				$tmp = array(
					"art_id" => $row->art_id,
					"art_title" => $row->art_title,
					"art_hits" => $row->art_hits,
					"art_catname" => $row->art_catname,
					"art_date" => $row->art_date,
					"art_author" => $row->art_author,
					"art_sectionid" => $row->art_sectionid,
					"art_slug" => $row->art_slug,
					"cat_slug" => $row->cat_slug
				);
				
				array_push($result_array, $tmp);
			}
		}
		else
		{
			// Error - no categories or no articles
		}	
		//echo '<pre>';
		//echo '====CATEGORY QUERY====';
		//print_r($result_array);
		//echo '</pre>';
		// returnig results in array
		return $result_array;
	}
	
	function getTotalAmount($config)
	{
		// getting information about user
		$user =& JFactory::getUser();
		$userId = (int) $user->get('id');
		$aid = $user->get('aid', 0);
		// getting access config
		$contentConfig = &JComponentHelper::getParams( 'com_content' );
		$access	= !$contentConfig->get('show_noauth');
		// getting date variables
		$nullDate	= $this->_db->getNullDate();
		$date =& JFactory::getDate();
		$now = $date->toMySQL();
		// initializing result variable
		$total_amount = 0;				
		// generating category clause
		for($i = 0; $i < count($config['categories']); $i++)
		{
			$catid_clause .= ($i == count($config['categories']) - 1) ? ' a.catid = '.$config['categories'][$i].' ' : ' a.catid = '.$config['categories'][$i].' OR ';
		}	
		// preparing query
		$query =   'SELECT 
						COUNT(*) AS total
					FROM 
						#__content AS a 
					INNER JOIN 
						#__categories AS c ON c.id = a.catid 
					INNER JOIN
						#__users AS u ON u.id = a.created_by	
					WHERE 
						a.state = 1 AND 
						( a.publish_up = '.$this->_db->Quote($nullDate).' OR a.publish_up <= '.$this->_db->Quote($now).' ) AND 
						( a.publish_down = '.$this->_db->Quote($nullDate).' OR a.publish_down >= '.$this->_db->Quote($now).' ) AND 
						'.($access ? ' a.access <= ' .(int) $aid. ' AND c.access <= ' .(int) $aid . ' AND ' : '').' 
						c.published = 1 AND 
						( ' . $catid_clause . ' )
					ORDER BY 
						'.(($date_type == 'created') ? 'a.created' : 'a.modified').' DESC';
		// run query
		$this->_db->setQuery($query);
		// getting query result
		$row = $this->_db->loadRow();
		// parsing rows
		if($row)
		{
			$total_amount = ceil($row[0] / $config['item_amount']);
		}
		else
		{
			// Error - no categories or no articles
		}	

		return $total_amount;
	}
	
	function getHeadlinesArrayAJAX($config,$total,$page)
	{
		if($page > $total || $page < 0){
			$page = 0;
		}
		
		// getting information about user
		$user =& JFactory::getUser();
		$userId = (int) $user->get('id');
		$aid = $user->get('aid', 0);
		// getting access config
		$contentConfig = &JComponentHelper::getParams( 'com_content' );
		$access	= !$contentConfig->get('show_noauth');
		// getting date variables
		$nullDate	= $this->_db->getNullDate();
		$date =& JFactory::getDate();
		$now = $date->toMySQL();
		// initializing result array
		$result_array = array();				
		// generating category clause
		for($i = 0; $i < count($config['categories']); $i++)
		{
			$catid_clause .= ($i == count($config['categories']) - 1) ? ' a.catid = '.$config['categories'][$i].' ' : ' a.catid = '.$config['categories'][$i].' OR ';
		}	
		// preparing query
		$query =   'SELECT 
						a.id AS art_id,
						a.title AS art_title, 
						'.(($config['date_type'] == 'created') ? 'a.created' : 'a.modified').' AS art_date,
						a.hits AS art_hits,
						
						u.'.($config["author_name"]).' AS art_author, 
						a.sectionid AS art_sectionid,
						c.title AS art_catname,
						CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) 
						ELSE a.id END AS art_slug, 
						CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(":", c.id, c.alias) 
						ELSE c.id END AS cat_slug
					FROM 
						#__content AS a 
					INNER JOIN 
						#__categories AS c ON c.id = a.catid 
					INNER JOIN
						#__users AS u ON u.id = a.created_by	
					WHERE 
						a.state = 1 AND 
						( a.publish_up = '.$this->_db->Quote($nullDate).' OR a.publish_up <= '.$this->_db->Quote($now).' ) AND 
						( a.publish_down = '.$this->_db->Quote($nullDate).' OR a.publish_down >= '.$this->_db->Quote($now).' ) AND 
						'.($access ? ' a.access <= ' .(int) $aid. ' AND c.access <= ' .(int) $aid . ' AND ' : '').' 
						c.published = 1 AND 
						( ' . $catid_clause . ' )
					ORDER BY 
						'.(($date_type == 'created') ? 'a.created' : 'a.modified').' DESC';
		// run query
		$this->_db->setQuery($query, $config['item_amount'] * $page, $config['item_amount']);
		// getting query result
		$rows = $this->_db->loadObjectList();
		// parsing rows
		if(count($rows) > 0)
		{
			// rows iteration
			foreach($rows as $row)
			{
				$tmp = array(
					"art_id" => $row->art_id,
					"art_title" => $row->art_title,
					"art_hits" => $row->art_hits,
					"art_catname" => $row->art_catname,
					"art_date" => $row->art_date,
					"art_author" => $row->art_author,
					"art_sectionid" => $row->art_sectionid,
					"art_slug" => $row->art_slug,
					"cat_slug" => $row->cat_slug
				);
				
				array_push($result_array, $tmp);
			}
		}
		else
		{
			// Error - no categories or no articles
		}	
		//echo '<pre>';
		//echo '====CATEGORY QUERY====';
		//print_r($result_array);
		//echo '</pre>';
		// returnig results in array
		return $result_array;
	}
}