<?php

/**
* GK News - cookie helper class
* @package Joomla!
* @Copyright (C) 2009 Gavick.com
* @ All rights reserved
* @ Joomla! is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @version $Revision: 1.0.0 $
**/

// no direct access
defined('_JEXEC') or die('Restricted access');
// Cookie helper
class GKNews_CookieHelper
{
	// order of sections
	var $ordering;
	// selected categories for sections
	var $categories;
	// togggle parameters for sections
	var $toggle;
	// intro article amount for sections
	var $intro;
	// more article amount for sections
	var $more;
	// cookie handler
	var $_cookie;
	// initialize
	function init($cookie)
	{
		// initializing array
		$this->ordering = array();
		$this->categories = array();
		$this->toggle = array();
		$this->intro = array();
		$this->more = array();
		// if cookie exists
		if(isset($cookie))
		{
			// pattern for cookie content
			$pattern = '/([0-9]+,[0-1]{1},[0-9]{1},[0-9]{1,2}:(([0-9]+,)|([0-9]+))+;)+/mi';
			if(preg_match($pattern, $cookie))
			{
				// set cookie
				$this->_cookie = $cookie;
				// parse cookie content
				$this->parseCookie();
				// return true
				return true;	
			}
		}
		else // if cookie doesn't exist
		{
			// return false
			return false;
		}
	}
	// function to parse cookie content
	function parseCookie()
	{
		$records = explode(';',$this->_cookie);
		
		foreach($records as $record)
		{
			if(!empty($record))
			{
				$parts = explode(':', $record);	
				$config = explode(',',$parts[0]);
				$section_id = $config[0];
				$toggle = $config[1];
				$intro = $config[2];
				$more = $config[3];
				$cats = explode(',',$parts[1]);
				
				array_push($this->ordering, $section_id);
				$this->categories["section".$section_id] = $cats;
				$this->toggle["section".$section_id] = $toggle;
				$this->intro["section".$section_id] = $intro;
				$this->more["section".$section_id] = $more;
			}
		}
		
		//echo '<pre>';
		//echo '_ordering';
		//print_r($this->ordering);
		//echo '_categories';
		//print_r($this->categories);
		//echo '_toggle';
		//print_r($this->toggle);
		//echo '_intro';
		//print_r($this->intro);
		//echo '_more';
		//print_r($this->more);
		//echo '</pre>';
	}
	// function to rewrite section_names array
	function rewriteSections($section_names)
	{
		$result_array = array();
		
		foreach($this->ordering as $order)
		{
			if(isset($section_names['section'.$order]))
			{
				$result_array['section'.$order] = $section_names['section'.$order];	
			}
		}
		
		return $result_array;
	}
}